Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.openjpa.kernel
Class FetchConfigurationImpl

    java.lang.Object
      org.apache.openjpa.kernel.FetchConfigurationImpl

All Implemented Interfaces:
  Serializable, Cloneable, FetchConfiguration, LockLevels, QueryFlushModes

Direct Known Subclasses:
  JDBCFetchConfigurationImpl

    public class FetchConfigurationImpl

extends Object
implements FetchConfiguration, Cloneable

Allows configuration and optimization of how objects are loaded from the data store.

Since:
  0.3.0
Author:
  Abe White, Pinaki Poddar
See Also:
  Serialized Form

Nested Class Summary
`protected static class` | `FetchConfigurationImpl.ConfigurationState` Configurable state shared throughout a traversal chain.

Field Summary

Fields inherited from interface org.apache.openjpa.kernel.FetchConfiguration
`DEFAULT`

Fields inherited from interface org.apache.openjpa.kernel.LockLevels
`LOCK_NONE, LOCK_READ, LOCK_WRITE`

Fields inherited from interface org.apache.openjpa.kernel.QueryFlushModes
`FLUSH_FALSE, FLUSH_TRUE, FLUSH_WITH_CONNECTION`

Constructor Summary
`` | `FetchConfigurationImpl()`
`protected` | `FetchConfigurationImpl(FetchConfigurationImpl.ConfigurationState state)`

Method Summary
`FetchConfiguration` | `addFetchGroup(String name)` Adds `group` to the set of fetch group names to use when loading objects.
`FetchConfiguration` | `addFetchGroups(Collection groups)` Adds `groups` to the set of fetch group names to use when loading objects.
`FetchConfiguration` | `addField(String field)` Adds `field` to the set of fully-qualified field names to use when loading objects.
`FetchConfiguration` | `addFields(Collection fields)` Adds `fields` to the set of fully-qualified field names to use when loading objects.
`FetchConfiguration` | `clearFetchGroups()` Clears the set of fetch group names to use when loading data.
`FetchConfiguration` | `clearFields()` Clears the set of field names to use when loading data.
`Object` | `clone()` Clone this instance.
`void` | `copy(FetchConfiguration fetch)` Copy the state from the given fetch configuration to this one.
`StoreContext` | `getContext()` Return the context assiciated with this configuration; may be null if it has not been set or this object has been serialized.
`int` | `getFetchBatchSize()` Return the fetch batch size for large result set support.
`Set` | `getFetchGroups()` Returns immutable set of names of the fetch groups that this component will use when loading objects.
`Set` | `getFields()` Returns the set of fully-qualified field names that this component will use when loading objects.
`int` | `getFlushBeforeQueries()` The query automatic flush configuration.
`Object` | `getHint(String name)` Returns the hint for the specific key, or null if the hint is not specified.
`int` | `getLockTimeout()` The number of milliseconds to wait for an object lock, or -1 for no limit.
`int` | `getMaxFetchDepth()` Return the maximum depth of fetched instance graph.
`boolean` | `getQueryCache()` Return whether or not query caching is enabled.
`int` | `getReadLockLevel()` The lock level to use for locking loaded objects.
`Set` | `getRootClasses()` Root classes for recursive operations.
`Set` | `getRootInstances()` Root instances for recursive operations.
`int` | `getWriteLockLevel()` The lock level to use for locking dirtied objects.
`boolean` | `hasFetchGroup(String group)` Return true if the given fetch group has been added.
`boolean` | `hasField(String field)` Return true if the given fully-qualified field has been added.
`void` | `lock()` Synchronize on internal lock if multithreaded is true.
`protected FetchConfigurationImpl` | `newInstance(FetchConfigurationImpl.ConfigurationState state)` Return a new hollow instance.
`ResultList` | `newResultList(ResultObjectProvider rop)` Return a new result list for the current fetch configuration.
`FetchConfiguration` | `removeFetchGroup(String group)` Remove the given fetch group.
`FetchConfiguration` | `removeFetchGroups(Collection groups)` Removes `groups` from the set of fetch group names to use when loading objects.
`FetchConfiguration` | `removeField(String field)` Remove the given fully-qualified field.
`FetchConfiguration` | `removeFields(Collection fields)` Removes `fields` from the set of fully-qualified field names to use when loading objects.
`boolean` | `requiresFetch(FieldMetaData fm)` Affirms if the given field requires to be fetched in the context of current fetch operation.
`FetchConfiguration` | `resetFetchGroups()` Resets the set of fetch groups to the list in the global configuration.
`void` | `setContext(StoreContext ctx)` Called automatically by the system to associate the fetch configuration with a context before use.
`FetchConfiguration` | `setFetchBatchSize(int fetchBatchSize)` Set the fetch batch size for large result set support.
`FetchConfiguration` | `setFlushBeforeQueries(int flush)` The query automatic flush configuration.
`void` | `setHint(String name, Object value)` Sets an arbitrary query hint that may be utilized during execution.
`FetchConfiguration` | `setLockTimeout(int timeout)` The number of milliseconds to wait for an object lock, or -1 for no limit.
`FetchConfiguration` | `setMaxFetchDepth(int depth)` Set the maximum depth of the fetched instance graph.
`FetchConfiguration` | `setQueryCache(boolean cache)` Control whether or not query caching is enabled.
`FetchConfiguration` | `setReadLockLevel(int level)` The lock level to use for locking loaded objects.
`FetchConfiguration` | `setRootClasses(Collection classes)` Root classes for recursive operations.
`FetchConfiguration` | `setRootInstances(Collection instances)` Root instances for recursive operations.
`FetchConfiguration` | `setWriteLockLevel(int level)` The lock level to use for locking dirtied objects.
`String` | `toString()`
`FetchConfiguration` | `traverse(FieldMetaData fm)` Traverse the given field to generate (possibly) a new configuration state.
`void` | `unlock()` Release internal lock if multithreaded is true.

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### FetchConfigurationImpl

    public FetchConfigurationImpl()

### FetchConfigurationImpl

    protected FetchConfigurationImpl(FetchConfigurationImpl.ConfigurationState state)

Method Detail

### getContext

    public StoreContext getContext()

  Description copied from interface: `FetchConfiguration`
  Return the context assiciated with this configuration; may be null if it has not been set or this object has been serialized.

  Specified by:
    `getContext` in interface `FetchConfiguration`

### setContext

    public void setContext(StoreContext ctx)

  Description copied from interface: `FetchConfiguration`
  Called automatically by the system to associate the fetch configuration with a context before use. The fetch configuration properties should be synchronized with the context's configuration object. Subclasses for specific back ends cannot rely on the context's configuration implementing their back end's configuration sub-interface.

  Specified by:
    `setContext` in interface `FetchConfiguration`

### clone

    public Object clone()

  Clone this instance.

  Specified by:
    `clone` in interface `FetchConfiguration`
  Overrides:
    `clone` in class `Object`

### newInstance

    protected FetchConfigurationImpl newInstance(FetchConfigurationImpl.ConfigurationState state)

  Return a new hollow instance.

### copy

    public void copy(FetchConfiguration fetch)

  Description copied from interface: `FetchConfiguration`
  Copy the state from the given fetch configuration to this one.

  Specified by:
    `copy` in interface `FetchConfiguration`

### getFetchBatchSize

    public int getFetchBatchSize()

  Description copied from interface: `FetchConfiguration`
  Return the fetch batch size for large result set support. Defaults to the `openjpa.FetchBatchSize` setting. Note that this property will be ignored under some data stores.

  Specified by:
    `getFetchBatchSize` in interface `FetchConfiguration`

### setFetchBatchSize

    public FetchConfiguration setFetchBatchSize(int fetchBatchSize)

  Description copied from interface: `FetchConfiguration`
  Set the fetch batch size for large result set support. Defaults to the `openjpa.FetchBatchSize` setting. Note that this property will be ignored under some data stores.

  Specified by:
    `setFetchBatchSize` in interface `FetchConfiguration`

### getMaxFetchDepth

    public int getMaxFetchDepth()

  Description copied from interface: `FetchConfiguration`
  Return the maximum depth of fetched instance graph. Defaults to `1`

  Specified by:
    `getMaxFetchDepth` in interface `FetchConfiguration`

### setMaxFetchDepth

    public FetchConfiguration setMaxFetchDepth(int depth)

  Description copied from interface: `FetchConfiguration`
  Set the maximum depth of the fetched instance graph.

  Specified by:
    `setMaxFetchDepth` in interface `FetchConfiguration`
  Parameters:
    `depth` - denotes limiting length of traversal path from a root instance. `-1` implies no limit. `0` is not permissible.

### getQueryCache

    public boolean getQueryCache()

  Description copied from interface: `FetchConfiguration`
  Return whether or not query caching is enabled. If this returns `true` but the datacache plugin is not installed, caching will not be enabled. If this returns `false`, query caching will not be used even if the datacache plugin is installed.

  Specified by:
    `getQueryCache` in interface `FetchConfiguration`

### setQueryCache

    public FetchConfiguration setQueryCache(boolean cache)

  Description copied from interface: `FetchConfiguration`
  Control whether or not query caching is enabled. This has no effect if the datacache plugin is not installed, or if the query cache size is set to zero.

  Specified by:
    `setQueryCache` in interface `FetchConfiguration`

### getFlushBeforeQueries

    public int getFlushBeforeQueries()

  Description copied from interface: `FetchConfiguration`
  The query automatic flush configuration.

  Specified by:
    `getFlushBeforeQueries` in interface `FetchConfiguration`

### setFlushBeforeQueries

    public FetchConfiguration setFlushBeforeQueries(int flush)

  Description copied from interface: `FetchConfiguration`
  The query automatic flush configuration.

  Specified by:
    `setFlushBeforeQueries` in interface `FetchConfiguration`

### getFetchGroups

    public Set getFetchGroups()

  Description copied from interface: `FetchConfiguration`
  Returns immutable set of names of the fetch groups that this component will use when loading objects. Defaults to the `openjpa.FetchGroups` setting. This set is not thread safe.

  Specified by:
    `getFetchGroups` in interface `FetchConfiguration`

### hasFetchGroup

    public boolean hasFetchGroup(String group)

  Description copied from interface: `FetchConfiguration`
  Return true if the given fetch group has been added.

  Specified by:
    `hasFetchGroup` in interface `FetchConfiguration`

### addFetchGroup

    public FetchConfiguration addFetchGroup(String name)

  Description copied from interface: `FetchConfiguration`
  Adds `group` to the set of fetch group names to use when loading objects.

  Specified by:
    `addFetchGroup` in interface `FetchConfiguration`

### addFetchGroups

    public FetchConfiguration addFetchGroups(Collection groups)

  Description copied from interface: `FetchConfiguration`
  Adds `groups` to the set of fetch group names to use when loading objects.

  Specified by:
    `addFetchGroups` in interface `FetchConfiguration`

### removeFetchGroup

    public FetchConfiguration removeFetchGroup(String group)

  Description copied from interface: `FetchConfiguration`
  Remove the given fetch group.

  Specified by:
    `removeFetchGroup` in interface `FetchConfiguration`

### removeFetchGroups

    public FetchConfiguration removeFetchGroups(Collection groups)

  Description copied from interface: `FetchConfiguration`
  Removes `groups` from the set of fetch group names to use when loading objects.

  Specified by:
    `removeFetchGroups` in interface `FetchConfiguration`

### clearFetchGroups

    public FetchConfiguration clearFetchGroups()

  Description copied from interface: `FetchConfiguration`
  Clears the set of fetch group names to use when loading data. After this operation is invoked, only those fields in the default fetch group (and any requested field) will be loaded when loading an object.

  Specified by:
    `clearFetchGroups` in interface `FetchConfiguration`

### resetFetchGroups

    public FetchConfiguration resetFetchGroups()

  Description copied from interface: `FetchConfiguration`
  Resets the set of fetch groups to the list in the global configuration.

  Specified by:
    `resetFetchGroups` in interface `FetchConfiguration`

### getFields

    public Set getFields()

  Description copied from interface: `FetchConfiguration`
  Returns the set of fully-qualified field names that this component will use when loading objects. Defaults to the empty set. This set is not thread safe.

  Specified by:
    `getFields` in interface `FetchConfiguration`

### hasField

    public boolean hasField(String field)

  Description copied from interface: `FetchConfiguration`
  Return true if the given fully-qualified field has been added.

  Specified by:
    `hasField` in interface `FetchConfiguration`

### addField

    public FetchConfiguration addField(String field)

  Description copied from interface: `FetchConfiguration`
  Adds `field` to the set of fully-qualified field names to use when loading objects.

  Specified by:
    `addField` in interface `FetchConfiguration`

### addFields

    public FetchConfiguration addFields(Collection fields)

  Description copied from interface: `FetchConfiguration`
  Adds `fields` to the set of fully-qualified field names to use when loading objects.

  Specified by:
    `addFields` in interface `FetchConfiguration`

### removeField

    public FetchConfiguration removeField(String field)

  Description copied from interface: `FetchConfiguration`
  Remove the given fully-qualified field.

  Specified by:
    `removeField` in interface `FetchConfiguration`

### removeFields

    public FetchConfiguration removeFields(Collection fields)

  Description copied from interface: `FetchConfiguration`
  Removes `fields` from the set of fully-qualified field names to use when loading objects.

  Specified by:
    `removeFields` in interface `FetchConfiguration`

### clearFields

    public FetchConfiguration clearFields()

  Description copied from interface: `FetchConfiguration`
  Clears the set of field names to use when loading data. After this operation is invoked, only those fields in the configured fetch groups will be loaded when loading an object.

  Specified by:
    `clearFields` in interface `FetchConfiguration`

### getLockTimeout

    public int getLockTimeout()

  Description copied from interface: `FetchConfiguration`
  The number of milliseconds to wait for an object lock, or -1 for no limit.

  Specified by:
    `getLockTimeout` in interface `FetchConfiguration`

### setLockTimeout

    public FetchConfiguration setLockTimeout(int timeout)

  Description copied from interface: `FetchConfiguration`
  The number of milliseconds to wait for an object lock, or -1 for no limit.

  Specified by:
    `setLockTimeout` in interface `FetchConfiguration`

### getReadLockLevel

    public int getReadLockLevel()

  Description copied from interface: `FetchConfiguration`
  The lock level to use for locking loaded objects.

  Specified by:
    `getReadLockLevel` in interface `FetchConfiguration`

### setReadLockLevel

    public FetchConfiguration setReadLockLevel(int level)

  Description copied from interface: `FetchConfiguration`
  The lock level to use for locking loaded objects.

  Specified by:
    `setReadLockLevel` in interface `FetchConfiguration`

### getWriteLockLevel

    public int getWriteLockLevel()

  Description copied from interface: `FetchConfiguration`
  The lock level to use for locking dirtied objects.

  Specified by:
    `getWriteLockLevel` in interface `FetchConfiguration`

### setWriteLockLevel

    public FetchConfiguration setWriteLockLevel(int level)

  Description copied from interface: `FetchConfiguration`
  The lock level to use for locking dirtied objects.

  Specified by:
    `setWriteLockLevel` in interface `FetchConfiguration`

### newResultList

    public ResultList newResultList(ResultObjectProvider rop)

  Description copied from interface: `FetchConfiguration`
  Return a new result list for the current fetch configuration.

  Specified by:
    `newResultList` in interface `FetchConfiguration`

### setHint

    public void setHint(String name,
                        Object value)

  Description copied from interface: `FetchConfiguration`
  Sets an arbitrary query hint that may be utilized during execution. The hint may be datastore-specific.

  Specified by:
    `setHint` in interface `FetchConfiguration`
  Parameters:
    `name` - the name of the hint
    `value` - the value of the hint

### getHint

    public Object getHint(String name)

  Description copied from interface: `FetchConfiguration`
  Returns the hint for the specific key, or null if the hint is not specified.

  Specified by:
    `getHint` in interface `FetchConfiguration`
  Parameters:
    `name` - the hint name

### getRootClasses

    public Set getRootClasses()

  Description copied from interface: `FetchConfiguration`
  Root classes for recursive operations. This set is not thread safe.

  Specified by:
    `getRootClasses` in interface `FetchConfiguration`

### setRootClasses

    public FetchConfiguration setRootClasses(Collection classes)

  Description copied from interface: `FetchConfiguration`
  Root classes for recursive operations.

  Specified by:
    `setRootClasses` in interface `FetchConfiguration`

### getRootInstances

    public Set getRootInstances()

  Description copied from interface: `FetchConfiguration`
  Root instances for recursive operations. This set is not thread safe.

  Specified by:
    `getRootInstances` in interface `FetchConfiguration`

### setRootInstances

    public FetchConfiguration setRootInstances(Collection instances)

  Description copied from interface: `FetchConfiguration`
  Root instances for recursive operations.

  Specified by:
    `setRootInstances` in interface `FetchConfiguration`

### lock

    public void lock()

  Description copied from interface: `FetchConfiguration`
  Synchronize on internal lock if multithreaded is true.

  Specified by:
    `lock` in interface `FetchConfiguration`

### unlock

    public void unlock()

  Description copied from interface: `FetchConfiguration`
  Release internal lock if multithreaded is true.

  Specified by:
    `unlock` in interface `FetchConfiguration`

### requiresFetch

    public boolean requiresFetch(FieldMetaData fm)

  Description copied from interface: `FetchConfiguration`
  Affirms if the given field requires to be fetched in the context of current fetch operation.

  Specified by:
    `requiresFetch` in interface `FetchConfiguration`

### traverse

    public FetchConfiguration traverse(FieldMetaData fm)

  Description copied from interface: `FetchConfiguration`
  Traverse the given field to generate (possibly) a new configuration state.

  Specified by:
    `traverse` in interface `FetchConfiguration`
  Returns:
    a new configuration state resulting out of traversal

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006 Apache Software Foundation. All Rights Reserved.